function param_t_list = LearnTransformations(data, ...
    labels, source_labels, param)
sources = unique(source_labels);
num_sources = length(sources);

param_t_list = cell(num_sources,1);
train_categories = sort(unique(labels.train.target));
tr_cat_ind = ismember(labels.train.source, train_categories);
for t = 1:num_sources
    s_ind = source_labels == sources(t);
    ind = s_ind & tr_cat_ind';
    fprintf('     Learning transformation for source cluster %d\n', sources(t));
    param_t = learnAsymmTransform(data.train.source(ind,:), labels.train.source(ind), ...
        data.train.target, labels.train.target, param);
    
    if ~isfield(param_t, 'S') || isempty(param_t.S)
        fprintf('Error: Missing transformation for cluster %d\n',sources(t));
    end
    param_t_list{t} = param_t;
end
end