% Author: Judy Hoffman (jhoffman@eecs.berkeley.edu)
% demo script to use with Domain Discovery code
% runs the domain discovery code 5 times and chooses result with lowest
% objective function. Final accuracy of the method is stored in 'acc' if
% domain labels are known. Predicted cluster assignments are stored in
% 'predicted_domain_labels'

% X - data matrix where each data point is a d-dimensional row
% y - row vector of category labels for each data point
% num_domains - choose the number of domains to separate the data into
% domain_labels - if domain labels are known add 
addpath util
predicted_domain_labels = [];
min_obj = inf; acc = 0;
for i = 1:5
    [domain_clusters, ~, objective, acc_] = DomainDiscovery (X, y, ...
        num_domains, domain_labels);
    if objective(end) < min_obj
        min_obj = objective(end);
        predicted_domain_labels = domain_clusters;
        acc = acc_;
    end
end