function bestAcc = clusterAccuracy(cluster, truth)

classes = unique(truth);

oldTruth = truth;
for c = 1:length(classes)
   class =  classes(c);
   truth(oldTruth==class)=c;
end

n = max(cluster);

possible = perms(1:n);

bestAcc = 0;
for i = 1:size(possible,1)
    tCluster = cluster;
    p = possible(i,:);
    for k = 1:n
        ind = find(cluster==k);
        tCluster(ind) = p(k)*ones(1,length(ind)); 
    end
    acc = sum(tCluster == truth')/length(truth);
    if acc > bestAcc
        bestAcc = acc;
    end
end

end
